SuperStrict

Rem

.zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz.
N` --------------------------------------------------------------------------- N
N   ______   _____   _____   _____  _     __  ___   ___ ___ ______  _______   N
N  |  ___ \ / ___ \ / ___ \ / ___ \| |   / / / _ \ |   V   |  ___ \|  _____|  N
N  | |___| | |   | | |___`| |___`| |__/ / / /_\ \| |\_/| | |___| | |___     N
N  |  ___  ( |   | |\____`. \____`.|  __ < |  ___  | |   | |  ____/|  ___|    N
N  | |___| | |___| |,-___| |,-___| | |  \ \| |   | | |   | | |     | |        N
N  |______/ \_____/ \_____/ \_____/|_|   |_|_|   |_|_|   |_|_|     |_|        N
N                                                                             N
N,---------------------------------------------------------------------------`.N
'zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz'
 (                                                                             )
  )                                - BCC #87 -                                (
 (                                                                             )
  )                           Holzchopf, 19.02.2016                           (
 (                     Light Engine started on 30.01.2016                      )
  )                                                                           (
 (                                                                             )
  )         Schlage die kleinen Gegner, damit du gengend Zaubertrnke        (
 (                    sammelst, um den Boss besiegen zu knnen.                )
  )                                                                           (
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  

v1.00
27.02.2016

v1.01
- added: possibility of absolute movement
- changed: way to choose difficulty
- fixed: drops no longer survive game end

End Rem

Framework brl.glmax2d
Import brl.timer
Import brl.pngloader
Import brl.linkedlist
Import brl.random
Import "_src\icons.o"

Include "_src\TLight.bmx"
Include "_src\TFigure.bmx"
Include "_src\HUD.bmx"
Include "_src\TFont.bmx"
Include "_src\TParticle.bmx"
Include "_src\TFigSpawnpoint.bmx"
Include "_src\TProjectile.bmx"
Include "_src\TSpell.bmx"
Include "_src\TDrop.bmx"
Include "_src\TAction.bmx"
Include "_src\functions.bmx"
Include "_src\SetIcon.bmx"

Include "_src\consts.bmx"
Include "_src\media.bmx"


' global app vars
Global state:Int = STATE_MENU
Global mx:Int, my:Int, mz:Int
Global mh1:Int
Global kdA:Int, kdS:Int, kdD:Int, kdW:Int
Global khHot:Int[8]
Global khEsc:Int
Global ms:Int
Global selectedSpell:Int	= 0

Global difficulty:Int
Global controls:Int
Global ai_idle_value:Int

Global gameover_msg:String

' objects and primitives
Global pointerlight:TLightSource = New TLightSource.Init(30, COL_POINTER)

Global player:TFigureHuman
Global boss:TFigureAI
Global spawnpoints:TFigSpawnpoint[3]

Light_SetStructure(hmMap)

Local runs:Int = 1
Local timer:TTimer = CreateTimer(60)
SeedRnd(MilliSecs())

AppTitle = "Bosskampf"
Graphics(SCREEN_WIDTH, SCREEN_HEIGHT)
HideMouse()
SetIcon(AppFile, GetActiveWindow())

While Not AppTerminate()
	'-----------------------------------------------------
	' input
	ms = MilliSecs()	
	mx		= MouseX()
	my		= MouseY()
	mz		= MouseZ()
	mh1		= MouseHit(MOUSE_LEFT)
	kdA		= KeyDown(KEY_A)
	kdS		= KeyDown(KEY_S)
	kdD		= KeyDown(KEY_D)
	kdW		= KeyDown(KEY_W)
	khEsc	= KeyHit(KEY_ESCAPE)
	For Local i:Int = 0 Until 8
		khHot[i] = KeyHit(SPELLS_HOTKEYS[i])
	Next
	
	'-----------------------------------------------------
	' update
	pointerlight.x = mx
	pointerlight.y = my

	selectedSpell = (selectedSpell -MouseZSpeed() +8) Mod 8
	
	TFigSpawnpoint.SpawnAll()
	For Local i:Int = 0 Until runs
		TProjectile.UpdateAll()
		TFigure.UpdateAll()
		TDrop.UpdateAll()
	Next
	TLightSource.UpdateAll()
	TParticle.UpdateAll()
	
	Select state
		Case STATE_GAME
			' victory
			If boss.health <= 0 then
				TidyUp()
				gameover_msg = GOT_WON
				state = STATE_GAMEOVER
			' defeat
			ElseIf player.health <= 0 then
				TidyUp()
				gameover_msg = GOT_LOST
				state = STATE_GAMEOVER
			EndIf
			' give up
			If khEsc then
				khEsc = False
				TidyUp()
				state = STATE_MENU
			EndIf
	End Select
	
	'-----------------------------------------------------
	' draw
	SetBlend(SOLIDBLEND)
	SetAlpha(1)
	SetColor(255,255,255)
	DrawImage(txMap, 0,0)
	SetColor(255,0,0)

	DrawAmbientLightning(90, 0.7, 0.7)
	
	TLightSource.DrawAll()
	
	TDrop.DrawAll()
	TFigure.DrawAll()
	TParticle.DrawAll()
	TProjectile.DrawAll()
	
	'-----------------------------------------------------
	' draw hud
	DrawHUD()

	Select state
		Case STATE_MENU
			If DrawButton("Schwierigkeit: " +DIFFICULTIES_CAPTIONS[difficulty], SCREEN_WIDTH/2, 128) then
				difficulty = (difficulty +1) Mod DIFFICULTIES_CNT
			EndIf
			If DrawButton("Steuerung: " +CONTROLS_CAPTIONS[controls], SCREEN_WIDTH/2, 224) then
				controls = (controls +1) Mod 2
			EndIf
			If DrawButton("Spiel starten", SCREEN_WIDTH/2, 416) then Start(DIFFICULTIES_IDLE[difficulty])
			If DrawButton("Spiel beenden", SCREEN_WIDTH/2, 512) Or khEsc then End
		Case STATE_GAMEOVER
			SetAlpha(1)
			SetColor(255,255,255)
			fntBig.Draw(gameover_msg, SCREEN_WIDTH/2, 320, ALIGN_CENTER, ALIGN_CENTER)
			If DrawButton("erneut spielen", SCREEN_WIDTH/2, 512) Or khEsc then
				state = STATE_MENU
			EndIf
	End Select

	DrawCursor()

	runs = WaitTimer(timer)
	Flip 0
Wend

Rem ------------------------------------------------------------------
Start game
End Rem ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function Start(pDifficulty:Int)
	ai_idle_value = pDifficulty

	TidyUp()

	' initialise new game
	player = New TFigureHuman
	player.Init(FIGURE_PLAYER, FIG_PLR_SETTINGS, 190,500)
	spawnpoints[0] = New TFigSpawnpoint.Init(FIGURE_ENEMY, FIG_ENY_SETTINGS, 190,160,80,3)
	spawnpoints[1] = New TFigSpawnpoint.Init(FIGURE_ENEMY, FIG_ENY_SETTINGS, 512,330,80,4)
	spawnpoints[2] = New TFigSpawnpoint.Init(FIGURE_ENEMY, FIG_ENY_SETTINGS, 834,500,80,3)
	
	TFigSpawnpoint.SpawnAll(True)

	boss = New TFigureAI
	boss.Init(FIGURE_BOSS, FIG_BOS_SETTINGS, 834,160)

	state = STATE_GAME
End Function

Rem ------------------------------------------------------------------
Tidy up (remove all figures)
End Rem ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function TidyUp()
	TFigure.list = New TList
	TProjectile.list = New TList
	TLightSource.list = New TList
	TLightObstacle.list	= New TList
	TFigSpawnpoint.list = New TList
	TDrop.list = New TList
	player = Null
	boss = Null
	For Local i:Int = 0 Until 3
		spawnpoints[i] = Null
	Next
	' undo removing pointer light
	TLightSource.list.AddLast(pointerlight)
End Function
