Rem ------------------------------------------------------------------
Spell class, holds actions for casting, creating projectile and hit
heal potions etc are considered to be spells too
End Rem ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Type TSpell
	' identification
	Field icon:Int
	Field action:TAction
	Field tooltip:String
	' costs
	Field health:Int
	Field mana:Int
	Field energy:Int, energyreq:Int
	Field count:Int

	Method Init:TSpell(pIcon:Int, pAction:TAction, pTooltip:String, pMana:Int, pEnergy:Int, pCount:Int = -1)
		icon	= pIcon
		action	= pAction
		tooltip	= pTooltip
		mana	= pMana
		energy	= pEnergy
		count	= pCount
		Return Self
	End Method
	
	Method Cast(pFigure:TFigure)
		If Avail(pFigure)
			pFigure.health	:- health
			pFigure.mana	:- mana
			pFigure.energy	= 0
			' use items
			If count >= 0 then
				pFigure.itemcount[count] :- 1
			EndIf
			action.Use(pFigure)
		EndIf
	End Method
	
	Method Avail:Int(pFigure:TFigure)
		' item count
		If count >= 0 And pFigure.itemcount[count] = 0 then
			Return False
		EndIf
		' stats
		If pFigure.health >= health And pFigure.mana >= mana And pFigure.energy >= energy then
			Return True
		EndIf
		Return False
	End Method
End Type
