Rem ------------------------------------------------------------------
Loot / Drops
End Rem ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Type TDrop
	Global list:TList = New TList
	
	Field posx:Int, posy:Int
	Field typ:Int
	Field color:Int[]
	Field count:Int
	
	Method Init:TDrop(pX:Int, pY:Int, pType:Int, pCount:Int)
		posx = pX
		posy = pY
		typ = pType
		color = DROP_COLORS[typ]
		count = pCount
		list.AddLast(Self)
		Return Self
	End Method
	
	Function UpdateAll()
		For Local d:TDrop = EachIn list
			d.Update()
		Next
	End Function
	
	Method Update()
		Local dx:Float, dy:Float, dist:Float
		dx = player.posx -posx
		dy = player.posy -posy
		dist = sqr(dx*dx +dy*dy)
		If dist <= player.radius+DROP_RADIUS then
			player.itemcount[typ] :+ count
			list.Remove(Self)
		EndIf
		New TParticle.Init(posx,posy, 0,0, Rnd(DROP_RADIUS *0.3, DROP_RADIUS *0.5), color, 50, 0.2)
	End Method
	
	Function DrawAll()
		For Local d:TDrop = EachIn list
			d.Draw()
		Next
	End Function
	
	Method Draw()
		SetBlend(ALPHABLEND)
		SetAlpha(1)
		SetColor(color[0], color[1], color[2])
		DrawImage(imgDrop, posx, posy)
	End Method
End Type
